



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【python cookbook】【数据结构与算法】18.将名称映射到序列的元素中</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【python cookbook】【数据结构与算法】18.将名称映射到序列的元素中</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-26 06:58:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>问题：希望通过<strong>名称</strong>来访问元素，减少结构中对位置的依赖性</p>
<p>解决方案：使用<strong>命名元组collections.namedtuple()</strong>。它是一个工厂方法，返回的是python中标准元组类型的子类，提供给它一个类型名称以及相应的<strong>字段名称</strong>，它就返回一个可实例化的类，为你以定义好的<strong>字段名称</strong>传入值等。</p>
<p>命名元组的主要作用在于将代码同它所控制的元素位置间进行解耦</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; from collections import namedtuple<br />
&gt;&gt;&gt; Sub=namedtuple('Subscriber',['addr','joined'])<br />
&gt;&gt;&gt; subscriber=Sub('lucy@example.com','2016-8-7')<br />
&gt;&gt;&gt; subscriber<br />
Subscriber(addr='lucy@example.com', joined='2016-8-7')<br />
&gt;&gt;&gt; subscriber.addr<br />
'lucy@example.com'<br />
&gt;&gt;&gt; subscriber.joined<br />
'2016-8-7'</pre>
</div>
<p>namedtuple的实例与普通的元组是可互换的，而且支持所有普通元组所支持的操作，例如索引和分解（unpacking）.</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; len(subscriber)<br />
2<br />
&gt;&gt;&gt; addr,joined=subscriber<br />
&gt;&gt;&gt; addr<br />
'lucy@example.com'<br />
&gt;&gt;&gt; joined<br />
'2016-8-7'<br />
&gt;&gt;&gt; </pre>
</div>
<p><strong>&nbsp;使用普通元组的代码：</strong></p>
<div>
<pre class="prettyprint linenums">def compute_cost(records):<br />
    total = 0.0<br />
    for rec in records:<br />
        total += rec[1] * rec[2]<br />
    return total</pre>
</div>
<p>通过位置来引用元素使得代码的表达力不够，而且也依赖于记录的具体结构。</p>
<p><strong>下面是使用命名元组的版本：</strong></p>
<div>
<pre class="prettyprint linenums"># example.py

from collections import namedtuple

Stock = namedtuple('Stock', ['name', 'shares', 'price'])

def compute_cost(records):<br />
    total = 0.0<br />
    for rec in records:<br />
        s = Stock(*rec)<br />
        total += s.shares * s.price<br />
    return total

# Some Data<br />
records = [<br />
    ('GOOG', 100, 490.1),<br />
    ('ACME', 100, 123.45),<br />
    ('IBM', 50, 91.15)<br />
]

print(compute_cost(records))</pre>
</div>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; ================================ RESTART ================================<br />
&gt;&gt;&gt;<br />
65912.5<br />
&gt;&gt;&gt; </pre>
</div>
<p>补充：</p>
<p>如果要构建涉及字典的大型数据结构，使用namedtuple会更加有效。但是注意，与字典不同的是，namedtuple是不可变的。例如：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; s=Stock('ACMS',100,123.45)<br />
&gt;&gt;&gt; s<br />
Stock(name='ACMS', shares=100, price=123.45)<br />
&gt;&gt;&gt; s.shares=75<br />
Traceback (most recent call last):<br />
  File "&lt;pyshell#2&gt;", line 1, in &lt;module&gt;<br />
    s.shares=75<br />
AttributeError: can't set attribute<br />
&gt;&gt;&gt; </pre>
</div>
<p>若要修改属性，可使用namedtuple实例的_replace()方法来实现。该方法会创建一个全新的命名元组，并对相应的值做替换；</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; s=s._replace(shares=75)<br />
&gt;&gt;&gt; s<br />
Stock(name='ACMS', shares=75, price=123.45)<br />
&gt;&gt;&gt; </pre>
</div>
<p>_replace()方法一个微妙的用途是它可以作为一种简便的方法填充具有可选或缺失字段的命名元组。</p>
<p>步骤：</p>
<p>1、创建一个包含默认值的&ldquo;原型&rdquo;元组；</p>
<p>2、使用_replace()方法创建一个新实例，把相应的值替换掉；</p>
<div>
<pre class="prettyprint linenums">from collections import namedtuple

Stock = namedtuple('Stock', ['name', 'shares', 'price','date','time'])

#创建一个包含默认值的&ldquo;原型&rdquo;元组<br />
stock_prototype=Stock('',0,0.0,None,None)

#创建一个函数实现将字典转化为Stock类型<br />
def dict_to_stock(s):<br />
    return stock_prototype._replace(**s)

a={'name':'ACMS','shares':100,'price':123.45}<br />
print(dict_to_stock(a))<br />
b={'name':'ACMS','shares':100,'price':123.45,'date':'2016-08-08'}<br />
print(dict_to_stock(b))<br />c={'name':'ACMS','price':123.45}<br />print(dict_to_stock(c))</pre>
</div>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; ================================ RESTART ================================<br />
&gt;&gt;&gt;<br />
Stock(name='ACMS', shares=100, price=123.45, date=None, time=None)<br />
Stock(name='ACMS', shares=100, price=123.45, date='2016-08-08', time=None)<br />Stock(name='ACMS', shares=0, price=123.45, date=None, time=None)<br />
&gt;&gt;&gt; </pre>
</div>
<p>注意：如果我们的目标是定义一个高效的数据结构，而且将来会修改各种实例属性，那么不推荐namedtuple！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kv5pj9.html">Spring Boot整合Activiti，查看流程图出现中文乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kk3168.html">Atitit cnchar simp best list &amp;&num;160&semi;汉字简化方案 最简化汉字256个</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wmm63q.html">Java之--Java语言基础组成（关键字、标识符、注释、常量和变量、运算符）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdex4l09.html">Java知识总结--数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydnny2q.html">Gulp-入门教程 搭配环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xoe3e8.html">HTML&amp;amp&semi;CSS基础学习笔记1&period;19-DIV标签1</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj4d5pq.html">c&plus;&plus; 常见问题之string</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zev2e9.html">Android Studio Gradle更新的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg7lre8.html">HDU--1358--KMP算法失配函数getfail&lpar;&rpar;的理解--Period</a>
		</li>
						<li><a href="https://www.batexi.com/a/8megpv0q.html">Django&plus;Vue打造购物网站&lpar;八&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyw17jq.html">java    &commat;Service  引入什么包</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvkrjg8.html">python使用ssdb的队列，用于替换canal&plus;rabbitmq</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjzge69.html">Laravel删除产品-CRUD之delete&lpar;destroy&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jv3mnq.html">&lbrack;转载&rsqb; 关于出现&OpenCurlyDoubleQuote;使用 UNION、INTERSECT 或 EXCEPT 运算符合并的所有查询必须在其目标列表中有相同数目的表达式&rdquo;错误的可能原因</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm2yvl9.html">Spring boot 默认静态资源路径与手动配置访问路径的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk2e6n8.html">ScriptManager&period;RegisterAsyncPostBackControl 方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpy5mz9.html">&lpar;1&rpar;R介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g31w3zq.html">android 命令行签名apk文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/96mjxpn8.html">iOS JavaScriptCore使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qd5p1y79.html">RobotFramework做接口自动化（内部接口需要登录token）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m966wmj9.html">LeetCode Integer to English Words</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlz3d68.html">SpringMVC中的controller默认是单例的原因</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnrx529.html">腾讯企鹅智酷100多张PPT：移动时代创业黄金法则</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyezgj9.html">Login failed知多少</a>
			</li>
						<li><a href="https://www.batexi.com/a/r9305on9.html">iOS UITableView的分割线短15像素，移动到最左边的方法&lpar;iOS8&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw763k8.html">DG - 将physical standby置于read-only模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd6mnv8.html">解决td标签上的position&colon;relative属性在各浏览器中的兼容性问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw775r8.html">Java基础之在窗口中绘图&mdash;&mdash;显示曲线的控制点（CurveApplet 2 displaying control points）</a>
			</li>
						<li><a href="https://www.batexi.com/a/49555je9.html">Java基础之一组有用的类&mdash;&mdash;使用正则表达式搜索子字符串（TryRegex&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p116k9.html">使用Java创建RESTful Web Service</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
